<?php
/*
Plugin Name: INK Official
Plugin URL: https://inkforall.com
Description: INK Block plugin allows you to import .ink files to wordpress posts / pages.
Version: 2.3
*/

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Block Initializer.
 */
require_once plugin_dir_path( __FILE__ ) . 'src/init.php';

add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'ink_action_links' );

function ink_action_links ( $links ) {
    $links_ink = array(
        '<a href="' . admin_url( 'options-general.php?page=inkimport' ) . '">Settings</a>',
    );
    return array_merge( $links, $links_ink );
}

function upload_ink_mimes($mimes = array()) {

	// Add a key and value for the INK file type
	$mimes['ink'] = "text/plain";

	return $mimes;
}
add_action('upload_mimes', 'upload_ink_mimes');

/* Config constant script */
global $const_names;

/* List of constants. Re-order to change the checkbox display order. */

$const_names = array(
	
	'ALLOW_UNFILTERED_UPLOADS' =>		'chk_allow_unfiltered_uploads_constant'
);


register_activation_hook( __FILE__, 'ink_update_config' );


function ink_update_config(){

	$config_file = ABSPATH.'wp-config.php';

	if(  file_exists($config_file) ) {
		
		
		// new method using regexp
		# getting old content of config file
		$content = @file_get_contents($config_file);
		# checking if constant is already defined but it false
		if(preg_match('/define\(\s*(\'|")ALLOW_UNFILTERED_UPLOADS(\'|"),\s*false\s*\);/', $content)){
			# updating the already defined constant
			@file_put_contents($config_file, preg_replace('/define\(\s*(\'|")ALLOW_UNFILTERED_UPLOADS(\'|"),\s*false\s*\);/', "define('ALLOW_UNFILTERED_UPLOADS',true);", $content));
		}
		# checking if constant is not defined already
		else if(!preg_match('/define\(\s*(\'|")ALLOW_UNFILTERED_UPLOADS(\'|"),\s*true\s*\);/', $content)){
			# adding the constant in the config file
			@file_put_contents($config_file, "\ndefine('ALLOW_UNFILTERED_UPLOADS',true);", FILE_APPEND);
		}
		# exiting the function
		return true;
		
	}

}
